/*****************************************************************************
*
* Copyright (C) 2003 Atmel Corporation
*
* File          : USI_UART_config.h
* Compiler      : IAR EWAAVR 2.28a
* Created       : 18.07.2002 by JLL
* Modified      : 02-10-2003 by LTA
*
* Support mail  : avr@atmel.com
*
* AppNote       : AVR307 - Half duplex UART using the USI Interface
*
* Description   : Header file for USI_UART driver
*
*
****************************************************************************/
#ifndef USI_UART_CONFIG_H_
#define USI_UART_CONFIG_H_
//********** USI UART Defines **********//

//#define SYSTEM_CLOCK             14745600
//#define SYSTEM_CLOCK             11059200
//#define SYSTEM_CLOCK              8000000UL
//#define SYSTEM_CLOCK              7372800
//#define SYSTEM_CLOCK              3686400
//#define SYSTEM_CLOCK              2000000
//#define SYSTEM_CLOCK              1843200
//#define SYSTEM_CLOCK              1000000UL
#define SYSTEM_CLOCK              F_CPU

//#define BAUDRATE                   115200
//#define BAUDRATE                    57600
//#define BAUDRATE                    38400UL
//#define BAUDRATE                    28800UL
#define BAUDRATE                    19200UL
//#define BAUDRATE                    14400
//#define BAUDRATE                     9600UL

//#define TIMER_PRESCALER           1
#define TIMER_PRESCALER           4

#define UART_RX_BUFFER_SIZE        4     /* 2,4,8,16,32,64,128 or 256 bytes */
#define UART_TX_BUFFER_SIZE        4

#define DO_TX				PA1				// DO
#define DI_RX 		 		PA0				// DI
#define USI_UART_PORT 	PORTA
#define USI_UART_DDR 	DDRA

#define UART_DEBUG 0

#if UART_DEBUG
extern uint8_t fudge;
#endif

//********** USI_UART Prototypes **********//

unsigned char Bit_Reverse( unsigned char );
void          USI_UART_Flush_Buffers( void );
void          USI_UART_Initialise_Receiver( void );
// void          USI_UART_Initialise_Transmitter( void );
void          USI_UART_Transmit_Byte( char );
char          USI_UART_Receive_Byte( void );
uint8_t       USI_UART_Data_In_Receive_Buffer( void );
uint8_t       USI_UART_Data_In_Transmit_Buffer( void );
void 		  USI_UART_puts( char *s );
void 		  USI_UART_puts_p( const char *progmem_s );			// transmit string from PROGMEM
#define 	  USI_UART_puts_P(__s)         USI_UART_puts_p(PSTR(__s))
void          timer_init( void );
#endif /* USI_UART_CONFIG_H_ */
