/*****************************************************************************
*
*
****************************************************************************/

#include <avr/io.h>
//#include <inavr.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <stdlib.h>
#include "USI_UART_config.h"
//#include "usi_spi_driver.h"
//#include "xx595.h"
//#include "lcd.h"
#include <avr/pgmspace.h>


   static void io_init(void) {
	PORTA = 0xFF; 		// alle Pull-ups an
	PORTB = 0xFF;

	return;
}

__attribute__ ((OS_main)) int main ( void )
{

	io_init();
	DIDR0 = (1 << PA4) | (1 << PA6) | (1 << PA7);
	timer_init();
	sei();  // SPI erst nach sei() möglich!

	USI_UART_Flush_Buffers();
    USI_UART_Initialise_Receiver();                          // Initialisation for USI_UART receiver

    for( ; ; )
    {
    	if( USI_UART_Data_In_Receive_Buffer() )
        {
        	 switch ( USI_UART_Receive_Byte() )
        	 {
        	 case 'D' :
        	 {
        		 uint8_t i;
        		 char input[4] = "";
        		 for(i=0; i<3;i++)
        		 {
        			 while (!(USI_UART_Data_In_Receive_Buffer()) )
        				 {;}
        			 input[i] = USI_UART_Receive_Byte();
        		 }
        		 USI_UART_puts_P("Input = ");
        		 USI_UART_puts(input);
        		 USI_UART_puts_P("\n");
        		 i = atoi(input);
        		 USI_UART_puts_P("Data = ");
        		 USI_UART_Transmit_Byte(i);
        		 USI_UART_puts_P("\n");
        	  }
        		 break;
     		case 'B' :
     		{
     			DIDR0 = (1 << PA4) | (1 << PA6) | (1 << PA7);
     			USI_UART_puts_P("DIDR0 set \n\r");
     		}
     		break;
     		case 'C' :
     		{
     			DIDR0 = 0;
     			USI_UART_puts_P("DIDR0 cleared \n\r");
     		}
     		break;
     		default :
        		 USI_UART_puts("Er1\n");
        	 }
        }
  //      sleep_mode();					// Sleep when waiting for next event
    }
}
